//
//  GradePanel.java
//  
//
//  Created by Christopher Garman on 4/6/05.
//

import javax.swing.*;
import javax.swing.event.TableModelEvent;
import javax.swing.table.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.net.*;
import java.util.*;
//import javax.mail.*;

public class GradePanel extends JPanel
{
	private final static String DEFAULT_COLUMN_NAMES[] = {"First Name","Last Name","E-mail"};
//	private final static String GRADE_FILE_HEADER = "#vcg";

	private final static String EMAIL_CONSTANT_STRINGS[] = {"email","e-mail"};
	private final static String SMTP_SERVER_NAME = "smtp.cs.pitt.edu";
	private final static int MAIL_PORT = 25;
	
	private final static String OK_220         = "220";
	private final static String OK_250         = "250";
	private final static String OK_354         = "354";
	private final static String CLOSE_221      = "221";
	private final static String END_SMTP_DATA  = ".";
	private final static String END_SMTP       = "QUIT";


	
	
	
	private JButton newButton;
	private JButton openButton;
	private JButton saveButton;
	private JButton emailButton;
	
	private ActionListener actionListener;
	
	private JButton newColumnButton;
	private JButton newStudentButton;
	
	private JPanel buttonPanel;
	private JTable gradeData;
	private JScrollPane gradeScroller;
	private JFileChooser fileChooser;// = new JFileChooser();

	private String gradeFileName = null;
	private String gradeFilePath = null;
//	private boolean isDirty = false;
	private String fromEmailAddress = null;
	
	public GradePanel()
	{
		super();
		setLayout(new BorderLayout());//new GridLayout(2,1));
		
		/*String []col = {"name","last","e-mail","one_more"};
		String [][]data ={
		{"chris","garman","garman@cs.pitt.edu","0"},{"a","b","c","d"}};*/
		fileChooser = new JFileChooser();
		gradeData = new JTable(new DefaultTableModel(new Object[0][0],new Object[0]));//new DefaultTableModel(data,col));
		//
		
		gradeScroller = new JScrollPane(gradeData);
		
		add(gradeScroller,BorderLayout.CENTER);
		
		actionListener = new HandleButtonClick();
		
		buttonPanel = new JPanel();
		
		newButton   = new JButton("New...");
		openButton  = new JButton("Open...");
		saveButton  = new JButton("Save...");
		emailButton = new JButton("E-mail Grades to selected");
		
		newColumnButton = new JButton("New Column...");

		newButton.addActionListener(actionListener);
		openButton.addActionListener(actionListener);		
		saveButton.addActionListener(actionListener);
		emailButton.addActionListener(actionListener);
		newColumnButton.addActionListener(actionListener);
		
	//	buttonPanel.add(newButton);
		buttonPanel.add(openButton);
		buttonPanel.add(saveButton);
		buttonPanel.add(emailButton);
		buttonPanel.add(newColumnButton);
		
		add(buttonPanel,BorderLayout.SOUTH);
	//	show();
	}
	
/*	private class FullGradeTable extends JTable
	{
		public void tableChanged(TableModelEvent e)
		{
			isDirty = true;
			super.tableChanged(e);
		}
	}*/
	
	public void addScore(Object [][]list,int numStudents,String testNumber)
	{
		int currentColumn = gradeData.getColumnCount();
		
		createNewColumn(false,"Test " + testNumber);
		
		for(int i = 0;i < list.length - 1;i++)
		{
			gradeData.setValueAt(list[i][1],i,currentColumn);
		}
	}
	
	private void createNewGradeFile()
	{
		int returnVal = 0;
		File selectedFile;
		//JFileChooser chooser = new JFileChooser();
		
		returnVal = fileChooser.showDialog(this,"Choose");
		
		if(returnVal == JFileChooser.APPROVE_OPTION)
		{
			selectedFile = fileChooser.getSelectedFile();
			gradeFileName = fileChooser.getName(selectedFile);
			gradeFilePath = selectedFile.getPath();
		//	System.out.println(gradeFileName);
			
		}
		else
		{
			/* do nothing */
		}
		
	}
	
	/* col name should be null if we are using user input */
	private void createNewColumn(boolean useUserInput, String colName)
	{
		String newColumnName = null;
		TableColumn newColumn = null;

		if(useUserInput)
		{
			newColumnName = JOptionPane.showInputDialog("New column name");
		}
		else
		{
			newColumnName = colName;
		}
		
		if(newColumnName != null)
		{
		//	System.out.println("Creating new column " + newColumnName);
			
		//	newColumn = new TableColumn();
		//	newColumn.setHeaderValue(newColumnName);
			((DefaultTableModel)gradeData.getModel()).addColumn(newColumnName,new Object[0]);
		}
		
	}
	
	private void openGradeFile()
	{
		int returnVal = 0;
		BufferedReader fileReader;
		File theFile;
		StringTokenizer tok;;
		String line,lastToken = ",",currentToken;
		Vector cols = new Vector();
		Vector row;
		
		fileChooser.setMultiSelectionEnabled(false);
		
		returnVal = fileChooser.showOpenDialog(this);
		
		if(returnVal == JFileChooser.APPROVE_OPTION)
		{
			theFile = fileChooser.getSelectedFile();
				
			gradeFilePath = theFile.getPath();
			gradeFileName = fileChooser.getName(theFile);
			try
			{
				fileReader = new BufferedReader(new FileReader(theFile));
				
				line = fileReader.readLine();
				tok = new StringTokenizer(line,",",true);
				
				while(tok.hasMoreTokens())
				{
					currentToken = tok.nextToken();
					
					if(currentToken.equals(lastToken))
					{
						cols.add("");
					}
					else if(!currentToken.equals(","))
					{
						cols.add(currentToken);
					}
					
					lastToken = currentToken;
						
						
					
				}
				
				gradeData.setModel(new DefaultTableModel(cols,0));
				
				lastToken = ",";
				
				while((line = fileReader.readLine()) != null)
				{
					tok = new StringTokenizer(line,",",true);
					
					row = new Vector();
					
					while(tok.hasMoreTokens())
					{
						//row.add(tok.nextToken());
						currentToken = tok.nextToken();
					
						if(currentToken.equals(lastToken))
						{
							row.add("");
						}
						else if(!currentToken.equals(","))
						{
							row.add(currentToken);
						}
						
						lastToken = currentToken;
					}
					
					((DefaultTableModel)gradeData.getModel()).addRow(row);
				}
			}
			catch(IOException e)
			{
				JOptionPane.showMessageDialog(this,e.toString(),"Error!",JOptionPane.ERROR_MESSAGE);
			}
		}
		else
		{
			/* do nothing */
		}
		
	}
	
	private void saveTable()
	{
		PrintWriter output;
		int returnVal = 0,numCols = 0,numRows = 0;
		
		if(gradeFileName == null)
		{
			createNewGradeFile();
			returnVal = JOptionPane.YES_OPTION;
		}
		else
		{
			returnVal = JOptionPane.showConfirmDialog(this,"Save changes to " + gradeFileName + "?","Save...", JOptionPane.YES_NO_OPTION, JOptionPane.WARNING_MESSAGE);
		}
		
		if(returnVal == JOptionPane.YES_OPTION)
		{
			try
			{
				output = new PrintWriter(new FileWriter(gradeFilePath));
				//output.println(GRADE_FILE_HEADER);
				
				numCols = gradeData.getColumnCount();
				
				//output.print(gradeData.getColumnName(0)
				for(int i = 0;i < numCols - 1;i++)
				{
					output.print(gradeData.getColumnName(i) + ",");
				}
				
				output.println(gradeData.getColumnName(numCols - 1));
				
				numRows = gradeData.getRowCount();
				
				for(int i = 0;i < numRows;i++)
				{
					for(int j = 0;j < numCols - 1;j++)
					{
						if(gradeData.getValueAt(i,j) != null)
						{
							output.print(gradeData.getValueAt(i,j) + ",");
						}
						else
						{
							output.print(",");
						}
					}
					
					if(gradeData.getValueAt(i,numCols - 1) != null)
					{
						output.println(gradeData.getValueAt(i,numCols - 1));
					}
					else
					{
						output.println();
					}
				}
				
				output.close();
			}
			catch(IOException e)
			{
				JOptionPane.showMessageDialog(this,e.toString(),"Error!",JOptionPane.ERROR_MESSAGE);
			}
		}
	}
	
	public void setStudents(IncomingMessage msg)
	{
		TableModel tm;
		
		int i = 0, messageSize = msg.getMessageSize();
		
		String [][]initialData = new String[messageSize][2];
		
//		System.out.println(msg + " " + msg.index);
		
		while(msg.hasMoreVariables())
		{
			initialData[i][0] = msg.getNextVariable();
			initialData[i][1] = msg.getNextVariable();
			
			i++;
		}
		
	//	System.out.println(i);
//		for(int j = 0;k < 
//		System.out.println(
	//	gradeData = new JTable(initialData,DEFAULT_COLUMN_NAMES);
	//	System.out.println(initialData[7][0] + " " + initialData[7][1]);
		
		for(int j = 0;j < DEFAULT_COLUMN_NAMES.length;j++)
		{
			createNewColumn(false,DEFAULT_COLUMN_NAMES[j]);
		}
		
		tm = gradeData.getModel();
		
		for(int j = 0;j < i;j++)
		{
			//gradeData.setValueAt(initialData[j][0],j,0);
			//gradeData.setValueAt(initialData[j][1],j,1);
			((DefaultTableModel)tm).addRow(initialData[j]);
		}
		//repaint();
	}
	
	private void sendEmail()
	{
		int numCols = 0,i = 0,numRows = 0;
		int []selectedRows;
		boolean foundEmailCol = false;
		Vector rowsToUse = new Vector();
		Vector emailAddresses = new Vector();
		
		String email;
		
		numCols = gradeData.getColumnCount();
		
		while(i < numCols && !foundEmailCol)
		{
			for(int j = 0;j < EMAIL_CONSTANT_STRINGS.length;j++)
			{
				if(gradeData.getColumnName(i).equalsIgnoreCase(EMAIL_CONSTANT_STRINGS[j]))
				{
					foundEmailCol = true;
				}
			}
			
			i++;
		}
		
		if(!foundEmailCol)
		{
			JOptionPane.showMessageDialog(this,"Cannot find an e-mail column","Error!",JOptionPane.ERROR_MESSAGE);
		}
		else
		{
			i--;
			
			numRows = gradeData.getRowCount();
			selectedRows = gradeData.getSelectedRows();
			
			if(selectedRows.length > 0)
			{
				
				for(int j = 0;j < selectedRows.length;j++)
				{
			//		System.out.println("selected: " + selectedRows[j]);
					
					email = (String)gradeData.getValueAt(selectedRows[j],i);
					
					if(email != null && email.indexOf("@") != (-1))
					{
						rowsToUse.add(new Integer(selectedRows[j]));
				//		System.out.println(selectedRows[j]);

					}
				}
				
				if(fromEmailAddress == null)
				{
					fromEmailAddress = JOptionPane.showInputDialog(this,"Enter your e-mail address: ");
				}
				
				for(int j = 0;j < rowsToUse.size();j++)
				{
					/* send an e-mail */
					sendAnEmailToRow(((Integer)rowsToUse.elementAt(j)).intValue(),i);
				}
			}
			else
			{
				JOptionPane.showMessageDialog(this,"No student selected","Error!",JOptionPane.ERROR_MESSAGE);
			}
			
			
		/*	for(int j = 0;j < numRows;j++)
			{
				email = (String)gradeData.getValueAt(j,i);
				
				if(email != null && email.indexOf("@") != (-1))
				{
					rowsToUse.add(new Integer(j));
					System.out.println(j);

				}
			}*/
			
			
						
		}
	}
	
	private void sendAnEmailToRow(int row,int emailCol)
	{
		int numCols = gradeData.getColumnCount();
		String toAddress = (String)gradeData.getValueAt(row,emailCol);
		String emailText = "{" + Global.className;
		Socket theSocket;
		
		//ioSocketAddress 
		PrintWriter outputToServer;
		BufferedReader serverInput;
		String reply;
		
		try
		{
			theSocket = new Socket(SMTP_SERVER_NAME,MAIL_PORT);
		
			outputToServer = new PrintWriter(theSocket.getOutputStream(),true);
			serverInput    = new BufferedReader(new InputStreamReader(theSocket.getInputStream()));
			
			reply = serverInput.readLine();
			if(!(reply.startsWith(OK_220)))
			{
				throw new IOException("Server dislikes this connection");
			}
			
			outputToServer.println("HELO " + theSocket.getInetAddress().getHostAddress());
			
			reply = serverInput.readLine();
			if(!(reply.startsWith(OK_250)))
			{
				throw new IOException("Server dislikes this connection: " + reply);
			}			
			
			outputToServer.println("MAIL FROM: <" + fromEmailAddress + ">");
			
			reply = serverInput.readLine();
			if(!(reply.startsWith(OK_250)))
			{
				throw new IOException("Server dislikes this connection: " + reply);
			}					
			
			outputToServer.println("RCPT TO: <" + toAddress + ">");
			
			reply = serverInput.readLine();
			if(!(reply.startsWith(OK_250)))
			{
				throw new IOException("Server dislikes this connection:" + reply);
			}		
			
			outputToServer.println("DATA");
			
			reply = serverInput.readLine();
			if(!(reply.startsWith(OK_354)))
			{
				throw new IOException("Server dislikes this connection:" + reply);
			}		
			
			
			for(int i = 0;i < numCols;i++)
			{
				
				emailText += ",";
				
				if(i > emailCol)
				{
					emailText += gradeData.getColumnName(i) + "=";
				}
				
				emailText += gradeData.getValueAt(row,i); 
			}
			
			emailText += "}";
			
			outputToServer.println(emailText);
			outputToServer.println(END_SMTP_DATA);
			
			reply = serverInput.readLine();
			if(!(reply.startsWith(OK_250)))
			{
				throw new IOException("Server dislikes this connection: " + reply);
			}		

			outputToServer.println(END_SMTP);
			
			if(!(serverInput.readLine().startsWith(CLOSE_221)))
			{
				throw new IOException("Server dislikes this connection: " + reply);
			}				//theSocket.connect();
			
			theSocket.close();
		}
		catch(IOException ioe)
		{
			JOptionPane.showMessageDialog(this,ioe.toString(),"Error!",JOptionPane.ERROR_MESSAGE);
		}

		
	}
	
	private class HandleButtonClick implements ActionListener
	{
		public void actionPerformed(ActionEvent e)
		{
			if(e.getSource() == emailButton)
			{
		//		System.out.println("Should be sending an e-mail");
				sendEmail();
			}
			else if(e.getSource() == saveButton)
			{
				saveTable();
		//		System.out.println("Should be saving updates to the grades");
			}
			else if(e.getSource() == newColumnButton)
			{
				createNewColumn(true,null);
			}
			else if(e.getSource() == newButton)
			{
				createNewGradeFile();
			}
			else if(e.getSource() == openButton)
			{
				openGradeFile();
			}
		}
		
	}
}
