// -------------------------------------------------------------------------
// Name: Christopher Santamaria
// Date: 
//--------------------------------------------------------------------------

import java.util.StringTokenizer;
import java.util.NoSuchElementException;

public class IncomingMessage
{
   boolean debug = false;

   // Keeps track of location within the message
   int index;

   // The actual tokenized message
   String[] message;

   // -------------------------------------------------------------------------
   // Name:
   // Return:
   // Purpose:
   // -------------------------------------------------------------------------
   public IncomingMessage( String msg, int serverType )
   {

      //message = msg.split( "$$$" );

      StringTokenizer st = new StringTokenizer( msg, "$$$" );

      message = new String[st.countTokens()];

      try {
         for( int i = 0; i < message.length; i++ )
            message[i] = st.nextToken();
      }
      catch( NoSuchElementException nse ) {

      }


      if( serverType == StaticFunctions.NAME_SERVER ) {
         index = 1;
      }
      else if( serverType == StaticFunctions.VIRTUAL_CLASSROOM_SERVER ) {
         if( message.length  < 3 )  // login message 
            index = 1;
         else // all others
            index = 3;
      }
      else if( serverType == StaticFunctions.FACE_ALIVE_SERVER ) {
         index = 1;
      }

      if( debug )
         debugConstructor();
   }

   // -------------------------------------------------------------------------
   // Name:
   // Return:
   // Purpose:
   // -------------------------------------------------------------------------
   private void debugConstructor()
   {
      System.out.println( "*** Debug Incoming Message from IncomingMessage( String, int ) ***" );
      System.out.println( "Message length: " + message.length );

      for( int i = 0; i < message.length; i++ )
         System.out.println( "i = " + i + " : " + message[i] );

      System.out.println( "******************************************************************" );
   }

   // -------------------------------------------------------------------------
   // Name:
   // Return:
   // Purpose:
   // -------------------------------------------------------------------------
   public String getNextVariable()
   {
      int i = index;
      index++;

      if( i >= message.length ) {

         if( debug ) {
            System.out.println( "*** ERROR: getNextVariable() ***" );
            System.out.println( "Attempting to access an index in message that is out of bounds" );
            System.out.println( "Returning empty string instead" );
         }

         return "";
      }

      return message[i];
   }

   // -------------------------------------------------------------------------
   // Name:
   // Return:
   // Purpose:
   // -------------------------------------------------------------------------
   public String getLastVariable()
   {
      return message[message.length - 1];
   }

   // -------------------------------------------------------------------------
   // Name:
   // Return:
   // Purpose:
   // -------------------------------------------------------------------------
   public boolean hasMoreVariables()
   {
      if( debug ) {
         System.out.println( "*** Debug hasMoreVariables() from IncomingMessage ***" );
         System.out.println( "current index = " + index + " : message.length = " + message.length );
      }

      if( index < message.length )
         return true;

      return false;
   }

   // -------------------------------------------------------------------------
   // Name:
   // Return:
   // Purpose:
   // -------------------------------------------------------------------------
   public String getName()
   {
      return message[1] + " " + message[2];
   }

   // -------------------------------------------------------------------------
   // Name:
   // Return:
   // Purpose:
   // -------------------------------------------------------------------------
   public String getFirstName()
   {
      return message[1];
   }

   // -------------------------------------------------------------------------
   // Name:
   // Return:
   // Purpose:
   // -------------------------------------------------------------------------
   public String getLastName()
   {
      return message[2];
   }

   // -------------------------------------------------------------------------
   // Name:
   // Return:
   // Purpose:
   // -------------------------------------------------------------------------
   public int getMessageSize()
   {
      return message.length;
   }

   // -------------------------------------------------------------------------
   // Name:
   // Return:
   // Purpose:
   // -------------------------------------------------------------------------
   public int getType()
   {
      return Integer.parseInt( message[3] );
   }

   // -------------------------------------------------------------------------
   // Name:
   // Return:
   // Purpose:
   // -------------------------------------------------------------------------
   public String string()
   {
      String retVal = new String();

      for( int i = 0; i < message.length; i++ )
         retVal += message[i];

      return retVal;
   }

   // -------------------------------------------------------------------------
   // Name:
   // Return:
   // Purpose:
   // -------------------------------------------------------------------------
   public String toString()
   {
      String retVal = new String( "Contents of an Incoming message: \n" + 
                                  "Message length: " + message.length + "\n" );

      for( int i = 0; i < message.length; i++ ) {
         retVal += "\tmessage[" + i + "] = " + message[i] + "\n";
      }

      return retVal;
   }

}