// -------------------------------------------------------------------------
// Name: Anna Nys
// Date: 11.15.04
//--------------------------------------------------------------------------

//Modified 11.17.04 - AN

import java.io.*;
import java.lang.Number;
import javax.swing.JOptionPane;

class Question {

	boolean debug = false;

	private String testNum="", number="";
	private String question="", answer="", short_answer="";
	private String choices[]={"","","","","",""};
	private String time="";   //in minutes
	private String type="";   //0=MC, 1=T/F, 2=SA
	private String fileName="";
	private String fileString="";
	private byte[] fileBytes=null;

	public Question()
	{
	}
	public String getQuestion() { return question; }
	public String getNumber() {return number; }
	public String[] getChoices() {return choices;}
	public String getType() { return type; }
	public String getTime() { return time; }
	public String getTestNum() { return testNum; }
	public String getAnswer() { return answer; }
	public String getShortAnswer() { return short_answer; }
	public String getFileName() { return fileName; }
	public String getFileString() { return fileString; }

	public void setNumber(String n)	{ number=n;	}
	public void setTestNum(String n){ testNum=n; }
	public void setQuestion(String q){ question=q; }
	public void setPicture (String n, byte[] f)
	{
		if (f != null)
		{
			fileName=n;
			fileBytes=f;
			fileString = "";

			if(debug)
				System.out.println("Size of file: "+fileBytes.length+" bytes");

			String temp = FileConverter.encodeBytes(f);

			if(debug)
				JOptionPane.showMessageDialog(null, temp, "File String", JOptionPane.INFORMATION_MESSAGE);

			//Get rid of carriage-return and newline chars
			String systemNewline = System.getProperty("line.separator");
			String[] array = temp.split(systemNewline);

			fileString = array[0]+"%@";
			for(int i=1; i<array.length-1; i++)
			{
				fileString+=array[i]+"%@";
			}
			fileString+=array[array.length-1];

			if(debug)
			{
				JOptionPane.showMessageDialog(null, fileString, "Processed file string", JOptionPane.INFORMATION_MESSAGE);
			}

		}
		else
			System.err.println("Byte array empty!\n");
	}

	public void setChoices(String c[])
	{
		for(int i=0; i<c.length; i++)
		{
			choices[i]=c[i];
		}
	}
	public void setAnswer(int i)
	{
		String index[]={"T","F","A","B","C","D","E"};
		answer=index[i];
	}
	public void setAnswer(String a)
	{
		answer = a;
	}
	public void setShortAnswer(String a)
	{
		short_answer=a;
	}
	public void setTime(String t)
	{
		time = t;
	}
	public void setTime(int i)
	{
		String index[]={"1","2","3","4","5"};
		time = index[i];
	}
	public void setType(String tp) { type=tp; }


	/* Method to convert IncomingMessage into Question object */
	public void loadQuestion(IncomingMessage msg)
	{
		if(debug)
		   JOptionPane.showMessageDialog(null, msg.toString(), "File String", JOptionPane.INFORMATION_MESSAGE);

		testNum = msg.getNextVariable();
		number = msg.getNextVariable();
 	    question = msg.getNextVariable();
		type = msg.getNextVariable();
		choices[0] = msg.getNextVariable();
		choices[1] = msg.getNextVariable();
		choices[2] = msg.getNextVariable();
		choices[3] = msg.getNextVariable();
		choices[4] = msg.getNextVariable();
		if(type.equals("2"))
			short_answer = msg.getNextVariable();
		else
			answer = msg.getNextVariable();
		time = msg.getNextVariable();
		fileName = msg.getNextVariable();
		fileString = msg.getNextVariable();
	}

	/* Method to convert Question object into OutgoingMessage */
	public void submitQuestion()
	{
	   OutgoingMessage msg = new OutgoingMessage(StaticFunctions.COMMAND_QUESTION);

	   msg.append( testNum );
	   msg.append( number );
	   msg.append( question );
	   msg.append( type );
	   msg.append( choices[0] );
	   msg.append( choices[1] );
	   msg.append( choices[2] );
	   msg.append( choices[3] );
	   msg.append( choices[4] );
	   if(type.equals("2"))
		   msg.append( short_answer );
	   else
		   msg.append( answer );
	   msg.append( time );
	   if(!fileName.equals("") && !fileString.equals(""))
	   {
		   msg.append( fileName );
		   msg.append( fileString);
	   }
	   else
	   {
		   msg.append( "null" );
		   msg.append( "null" );
	   }

	   if(debug)
		   JOptionPane.showMessageDialog(null, msg.getMessage().toString(), "File String", JOptionPane.INFORMATION_MESSAGE);

	   //Send the message
	   Global.virtualClassroomThread.virtualClassroomSend(msg);
	}
}