// -------------------------------------------------------------------------
// Name: Anna Nys
// Date: 4.1.05
//--------------------------------------------------------------------------

import org.jdom.*;
import org.jdom.input.*;
import org.jdom.output.*;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;

public class RIndexToXML
{
	public static boolean debug = false;

	static public void Save ( Document doc, String fileName ) throws IOException
	{
		File file = null;
		try
		{
			file = new File (fileName);
		}
		catch( Exception e )
		{
			e.printStackTrace(System.err);
		}

		XMLOutputter outputter = new XMLOutputter();
		FileWriter writer = new FileWriter( file );
		outputter.output( doc, writer );
		writer.close();
	}
	static public void Convert( String text, String fileName )
	{
		String xmlFileName = null;
		String arr[] = null;

		arr = fileName.split("\\.");
		xmlFileName = arr[0] + ".xml";

		if(debug)
			System.out.println(xmlFileName);

		SAXBuilder builder = new SAXBuilder();  // parameters control validation, etc
		Document doc = null;

		Element root = new Element("rIndex");
		doc = new Document(root);

		String result [] = text.split("\n");
		String fields [] = null;

		Element keyword = null;
		Element name = null;
		Element frequency = null;

		for (int x=1; x<result.length; x++)
	    {
			if(debug)
				System.out.println(result[x]);

			//Split into: "keyword, name1, name2,...,frequency"
			fields = result[x].split(";");
			keyword = new Element("keyword");
			keyword.setAttribute("string",fields[0]);

			for (int i=1; i<fields.length-1; i++)
			{
				name = new Element("name").setText(fields[i]);
				keyword.addContent(name);
			}

			frequency = new Element("frequency").setText(fields[fields.length-1]);
			keyword.addContent(frequency);
			root.addContent(keyword);
		}

		try {
			Save( doc, xmlFileName );
		}
		catch ( Exception e)
		{
			e.printStackTrace(System.err);
		}
	}
}