import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class RelationalIndexWindow extends JDialog implements ActionListener
{
   private JLabel transJLabel = null;
   private JLabel keysJLabel = null;
   private JLabel freqJLabel = null;

   private JTextField transJTextField = null;
   private JTextField keysJTextField = null;
   private JTextField freqJTextField = null;

   private JButton okButton = null;
   private JButton cancelButton = null;

   private String transcriptFileName = null;
   private String keywordFileName = null;
   private String freqFileName = null;

   // -------------------------------------------------------------------------
   // Name:
   // Return:
   // Purpose:
   // -------------------------------------------------------------------------
   public RelationalIndexWindow( String tFile, String kFile, String rFile )
   {
      super( (JFrame)null, "Virtual Classroom RelationalIndex", true );

      Container c = getContentPane();
      c.setLayout( new FlowLayout() );

      // transJLabel
      transJLabel = new JLabel( "Transcript File: " );
      c.add( transJLabel );

      transJTextField = new JTextField( 20 );
      transJTextField.setText( tFile );
      c.add( transJTextField );

      // keysJLabel
      keysJLabel = new JLabel( "Keyword File: " );
      c.add( keysJLabel );

      keysJTextField = new JTextField( 20 );
      keysJTextField.setText( kFile );
      c.add( keysJTextField );

      // freqJLabel
      freqJLabel = new JLabel( "Frequency File: " );
      c.add( freqJLabel );

      freqJTextField = new JTextField( 20 );
      freqJTextField.setText( rFile );
      c.add( freqJTextField );

      // Buttons
      okButton = new JButton( "Ok" );
      c.add( okButton );
      okButton.addActionListener( this );

      cancelButton = new JButton( "Cancel" );
      c.add( cancelButton );
      cancelButton.addActionListener( this );

      setDefaultCloseOperation( DO_NOTHING_ON_CLOSE );
   }

   // -------------------------------------------------------------------------
   // Name:
   // Return:
   // Purpose: Show the initialized dialog.  The first argument should
   //          be null if you want the dialog to come up in the center
   //          of the screen.  Otherwise, the argument should be the
   //          component on top of which the dialog should appear.
   // -------------------------------------------------------------------------
   public void showDialog(Component comp)
   {
      setSize( 350, 150 );
      setLocationRelativeTo( comp );
      setVisible( true );
   }

   // -------------------------------------------------------------------------
   // Name:
   // Return:
   // Purpose:
   // -------------------------------------------------------------------------
   public void actionPerformed( ActionEvent e )
   {

      if( e.getSource() == okButton )
      {

         try {
            transcriptFileName = transJTextField.getText();
            keywordFileName = keysJTextField.getText();
            freqFileName = freqJTextField.getText();
         }
         catch( NullPointerException npe ) {

         }

         // Make sure that all the text fields are filled in
         if( transcriptFileName.equals( "" ) ||
             keywordFileName.equals( "" ) ||
             freqFileName.equals( "" ) )
         {
            JOptionPane.showMessageDialog(
                                     null,
                                     "Please enter a transcript file, keyword file and relational file!",
                                     "File Error",
                                     JOptionPane.ERROR_MESSAGE );

            return;
         }

         setVisible( false );
      }
      else if( e.getSource() == cancelButton )
      {
         setVisible( false );
      }

   }  // End void actionPerformed( ActionEvent )

   // -------------------------------------------------------------------------
   // Name:
   // Return:
   // Purpose:
   // -------------------------------------------------------------------------
   public String getTranscriptFileName()
   {
      return transcriptFileName;
   }  // End String getTranscriptFileName()

   // -------------------------------------------------------------------------
   // Name:
   // Return:
   // Purpose:
   // -------------------------------------------------------------------------
   public String getKeywordFileName()
   {
      return keywordFileName;
   }  // End String getKeywordFileName()

   // -------------------------------------------------------------------------
   // Name:
   // Return:
   // Purpose:
   // -------------------------------------------------------------------------
   public String getFreqFileName()
   {
      return freqFileName;
   }  // End String getKeywordFileName()


   public void clear()
   {
      transJTextField.setText( "" );
      keysJTextField.setText( "" );
      freqJTextField.setText( "" );
   }

}  // End LoginWindow Class