// -------------------------------------------------------------------------
// Name: Anna Nys
// Date: 11.15.04
//--------------------------------------------------------------------------

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class Respond extends JPanel {    
    JComboBox combo_answer;
    JButton btn_Submit;
	JButton btn_Clear;
	JLabel lbl_answer;
	JTextField txt_answer;	
	
	Answer newAnswer;			
	
    public Respond() {
        		
		AnswerLayout customLayout = new AnswerLayout();						
		
        setLayout(customLayout);       
		
		newAnswer = new Answer();		
		
		lbl_answer = new JLabel("Answer:");
        add(lbl_answer);  //c0
        
		combo_answer = new JComboBox();
		combo_answer.setForeground(Color.blue);
        combo_answer.addItem("True");
        combo_answer.addItem("False");
        combo_answer.addItem("A");
        combo_answer.addItem("B");
        combo_answer.addItem("C");
        combo_answer.addItem("D");
        combo_answer.addItem("E");
        add(combo_answer);  //c1
		
		txt_answer = new JTextField("");	
		txt_answer.setForeground(Color.blue);
		txt_answer.setSize(30,5);
		add(txt_answer); //c2

        btn_Submit = new JButton("Submit");		
        add(btn_Submit);  //c3          
		
		btn_Clear = new JButton("Clear");
		add(btn_Clear);  //c4				
				
		ButtonHandler btn_handler = new ButtonHandler();
		btn_Submit.addActionListener(btn_handler);
        btn_Clear.addActionListener(btn_handler);				
       
    }	
	
	//inner class for button event handling
	private class ButtonHandler implements ActionListener{
		public void actionPerformed(ActionEvent e)
		{
			if (e.getSource() == btn_Submit)
			{			 				
				if (txt_answer.isEnabled())
				{
					newAnswer.setShortAnswer(txt_answer.getText());					
					newAnswer.setType("1");
				}
				else
				{
					newAnswer.setAnswer(combo_answer.getSelectedIndex());
					newAnswer.setType("0");
				}
				
				if( (newAnswer.getAnswer()).equals("") && (newAnswer.getShortAnswer()).equals(""))
					JOptionPane.showMessageDialog(null,"Please enter an answer","Error",JOptionPane.WARNING_MESSAGE);
				else
				{				
					newAnswer.setFname(Global.myFirstName);
					newAnswer.setLname(Global.myLastName);										
					
					txt_answer.setText("");
					newAnswer.submitAnswer();
				}
			}
			else
			{
				txt_answer.setText("");
			}
		}
	}
	
	public void startNewAnswer()
	{
		newAnswer = new Answer();		
	}
	public void enableShortAnswer()
	{
		txt_answer.setEnabled(true);
		combo_answer.setEnabled(false);
	}
	public void enableMCAnswer()
	{
		txt_answer.setEnabled(false);					  
		combo_answer.setEnabled(true);		
	}
	public void enablePanel()
	{
		combo_answer.setEnabled(true);
		btn_Submit.setEnabled(true);
		btn_Clear.setEnabled(true);
		txt_answer.setEnabled(true);
	}
	public void disablePanel()
	{
		combo_answer.setEnabled(false);
		btn_Submit.setEnabled(false);
		btn_Clear.setEnabled(false);
		txt_answer.setEnabled(false);
	}
 
}

class AnswerLayout implements LayoutManager {

    public AnswerLayout() {
    }

    public void addLayoutComponent(String name, Component comp) {
    }

    public void removeLayoutComponent(Component comp) {
    }

    public Dimension preferredLayoutSize(Container parent) {
        Dimension dim = new Dimension(0, 0);

        Insets insets = parent.getInsets();
        dim.width = 300 + insets.left + insets.right;
        dim.height = 200 + insets.top + insets.bottom;

        return dim;
    }

    public Dimension minimumLayoutSize(Container parent) {
        Dimension dim = new Dimension(0, 0);
        return dim;
    }

    public void layoutContainer(Container parent) {
        Insets insets = parent.getInsets();

        Component c;
		c = parent.getComponent(0);
        if (c.isVisible()) {c.setBounds(insets.left+5,insets.top+10,72,24);}
        c = parent.getComponent(1);
        if (c.isVisible()) {c.setBounds(insets.left+5,insets.top+34,90,24);}        
		c = parent.getComponent(2);
		if (c.isVisible()) {c.setBounds(insets.left+125,insets.top+34,150,24);}
        c = parent.getComponent(3);
        if (c.isVisible()) {c.setBounds(insets.left+5,insets.top+70,90,24);}        
		c = parent.getComponent(4);
		if (c.isVisible()) {c.setBounds(insets.left+125,insets.top+70,90,24);}        
	}
}
