// -------------------------------------------------------------------------
// Name: Christopher Santamaria
// Date: 
//--------------------------------------------------------------------------

import java.util.Timer;
import java.util.TimerTask;

public class SleepTimer
{
   private final int MILLI_SECONDS = 1000;
   private final int SECONDS = 60;
   private final int MINUTES = 10;

   private boolean sleeping = false;
   private int activity = 0;
   private int previousStatus = 1;

   Timer timerOne = null;

   // -------------------------------------------------------------------------
   // Name:
   // Return:
   // Purpose:
   // -------------------------------------------------------------------------
   public SleepTimer()
   {
      timerOne = new Timer();
      timerOne.scheduleAtFixedRate( new SleepTask(), MILLI_SECONDS * SECONDS * MINUTES, MILLI_SECONDS * SECONDS * MINUTES );
   }

   // -------------------------------------------------------------------------
   // Name:
   // Return:
   // Purpose:
   // -------------------------------------------------------------------------
   public void setSleeping( boolean b )
   {
      sleeping = b;
   }

   // -------------------------------------------------------------------------
   // Name:
   // Return:
   // Purpose:
   // -------------------------------------------------------------------------
   public boolean isSleeping()
   {
      return sleeping;
   }

   // -------------------------------------------------------------------------
   // Name:
   // Return:
   // Purpose:
   // -------------------------------------------------------------------------
   public void resetActivity()
   {
      activity = 0;
   } 

   // -------------------------------------------------------------------------
   // Name:
   // Return:
   // Purpose:
   // -------------------------------------------------------------------------
   public void incrementActivity()
   {
      activity++;
   }

   // -------------------------------------------------------------------------
   // Name:
   // Return:
   // Purpose:
   // -------------------------------------------------------------------------
   public int getActivity()
   {
      return activity;
   }

   // -------------------------------------------------------------------------
   // Name:
   // Return:
   // Purpose:
   // -------------------------------------------------------------------------
   public void setLastStatus( int status )
   {
      previousStatus = status;
   }

   // -------------------------------------------------------------------------
   // Name:
   // Return:
   // Purpose:
   // -------------------------------------------------------------------------
   public void restorePreviousStatus()
   {
      sendUpdateMessage( previousStatus );
   }

   // -------------------------------------------------------------------------
   // Name:
   // Return:
   // Purpose:
   // -------------------------------------------------------------------------
   private void sendUpdateMessage( int status )
   {
      OutgoingMessage msg = new OutgoingMessage();

      msg.append( Integer.toString( StaticFunctions.COMMAND_UPDATE ) );
      msg.append( Integer.toString( status ) );

      Global.virtualClassroomThread.virtualClassroomSend( msg );
   }

   // -------------------------------------------------------------------------
   // Name:
   // Return:
   // Purpose:
   // -------------------------------------------------------------------------
   protected void finalize()
   {
      timerOne.cancel();
      timerOne = null;
   }

} // End SleepTimer Class

