// -------------------------------------------------------------------------
// Name: Christopher Santamaria
// Date: 
//--------------------------------------------------------------------------

import javax.swing.*;
import javax.swing.border.*;
import java.awt.event.*;
import java.awt.*;
import java.util.*;

public class StaticFunctions
{
   // Student Status (Online Status numbers and offline)
   static public final int OFFLINE = 0;
   static public final int HAPPY = 1;
   static public final int ONLINE = 1;
   static public final int SAD = 2;
   static public final int WINKING = 3;
   static public final int CRYING = 4;
   static public final int YES = 5;
   static public final int NO = 6;
   static public final int SLEEPING = 7;

   // Type
   static public final int TEACHER = 0;
   static public final int STUDENT = 1;

   // Whiteboard
   static public final int LINE = 0;
   static public final int RECTANGLE = 1;
   static public final int ELLIPSE = 2;
   static public final int CIRCLE = 3;
   static public final int TEXT = 4;

   static public final int SOLID = 0;
   static public final int DOTTED = 1;
   static public final int CLEAR = 1;

   // Message Spilter
   static public final String DELIMITER = "$$$";
   static public final byte[] packageArray = { (byte) 194, (byte) 195, (byte) 196 };
   static public final String PACKAGE_HEAD = new String( packageArray );//"#193#194#195";

   // Newline in Delphi
   static public final char delphiNewline = (char) 192; //192 ascii;

   // Commands Recieved from the Virtual Classroom server version 3.0
   static public final int COMMAND_LOGIN = 0;
   static public final int COMMAND_URL = 1;
   static public final int COMMAND_MESSAGE = 2;
   static public final int COMMAND_BOARD = 3;
   static public final int COMMAND_UPDATE = 4;
   static public final int COMMAND_PUSH = 5;
   static public final int COMMAND_QUIT = 6;
   static public final int COMMAND_TEACHER_ONLINE = 7;
   static public final int COMMAND_SYSTEM_MESSAGE = 8;
   static public final int COMMAND_UPDATE_LIST = 9;
   static public final int COMMAND_ERROR = 10;
   static public final int COMMAND_MEETING = 11;
   static public final int COMMAND_MESSAGE_TEACHER = 12;
   static public final int COMMAND_MESSAGE_PRIVATE = 13;
   static public final int COMMAND_ONLY_TEACHER = 14;
   static public final int COMMAND_DISABLE_PRIVATE = 15;
   static public final int COMMAND_START_TEST = 16;
   static public final int COMMAND_QUESTION = 17;
   static public final int COMMAND_ANSWER = 18;
   static public final int COMMAND_END_TEST = 19;
   static public final int COMMAND_GRADES = 20;


   // Send Command #
   static public final int SEND_LOGIN = 1;
   static public final int SEND_LOGOUT = 2;
   static public final int SEND_MESSAGE = 3;
   static public final int SEND_URL = 4;
   static public final int SEND_PUSH = 5;

   // Command for student with name server
   static public final int NAME_SERVER_LOGIN = 0;
   static public final int NAME_SERVER_COURSELIST = 1;
   static public final int NAME_SERVER_IP = 2;
   static public final int NAME_SERVER_STUDENTLIST = 3;

   static public final int NAME_SERVER_DATAFORMAT = 4;
   static public final int NAME_SERVER_END = 4;

   static public final int NAME_SERVER_ERROR = 9;

   // Face Alive Server
   static public final int FACE_SERVER_PUSH = 0;
   static public final int FACE_SERVER_PULL = 1;
   static public final int FACE_SERVER_RECV = 2;

   // Server Constants
   static public final int NAME_SERVER = 0;
   static public final int VIRTUAL_CLASSROOM_SERVER = 1;
   static public final int FACE_ALIVE_SERVER = 2;

   // Don't have a clue... why this is here
   static public final int CODE_STUDENT = 1;

   // Line seperator constant
   static String newline = System.getProperty("line.separator");

   //
   static private final Random r = new Random();


   // -------------------------------------------------------------------------
   // Name:
   // Return:
   // Purpose:
   // -------------------------------------------------------------------------
   static public String[] parseMessage( String msg )
   {
      String[] spiltMessage = msg.split( DELIMITER );

      return spiltMessage;
   }

   // -------------------------------------------------------------------------
   // Name:
   // Return:
   // Purpose:
   // -------------------------------------------------------------------------
   static public Color computeColor( int index )
   {
      switch( index )
      {
         case 0:
            return Color.BLACK;
         case 1:
            return Color.BLUE;
         case 2:
            return Color.CYAN;
         case 3:
            return Color.DARK_GRAY;
         case 4:
            return Color.GRAY;
         case 5:
            return Color.GREEN;
         case 6:
            return Color.LIGHT_GRAY;
         case 7:
            return Color.MAGENTA;
         case 8:
            return Color.ORANGE;
         case 9:
            return Color.PINK;
         case 10:
            return Color.RED;
         case 11:
            return Color.WHITE;
         case 12:
            return Color.YELLOW;
      }

      return Color.BLACK;
   }

   // -------------------------------------------------------------------------
   // Name:
   // Return:
   // Purpose:
   // -------------------------------------------------------------------------
   static public int computeColor( Color color )
   {
      if( Color.BLACK.equals( color ) )
         return 0;
      if( Color.BLUE.equals( color ) )
         return 1;
      if( Color.CYAN.equals( color ) )
         return 2;
      if( Color.DARK_GRAY.equals( color ) )
         return 3;
      if( Color.GRAY.equals( color ) )
         return 4;
      if( Color.GREEN.equals( color ) )
         return 5;
      if( Color.LIGHT_GRAY.equals( color ) )
         return 6;
      if( Color.MAGENTA.equals( color ) )
         return 7;
      if( Color.ORANGE.equals( color ) )
         return 8;
      if( Color.PINK.equals( color ) )
         return 9;
      if( Color.RED.equals( color ) )
         return 10;
      if( Color.WHITE.equals( color ) )
         return 11;
      if( Color.YELLOW.equals( color ) )
         return 12;

      return 0;
   }

   // -------------------------------------------------------------------------
   // Name:
   // Return:
   // Purpose: To be compatiable with Xin's version
   // -------------------------------------------------------------------------
   static public int computeColorComp( Color color )
   {
      if( Color.BLACK.equals( color ) )
         return 0;
      if( Color.BLUE.equals( color ) )
         return 16711680;
      if( Color.CYAN.equals( color ) )
         return 16776960;
      if( Color.DARK_GRAY.equals( color ) )
         return 8421504;
      if( Color.GRAY.equals( color ) )
         return 8421504;
      if( Color.GREEN.equals( color ) )
         return 32768;
      if( Color.LIGHT_GRAY.equals( color ) )
         return 12632256;
      if( Color.MAGENTA.equals( color ) )
         return 16711935;
      if( Color.ORANGE.equals( color ) )
         return 255;
      if( Color.PINK.equals( color ) )
         return 255;
      if( Color.RED.equals( color ) )
         return 255;
      if( Color.WHITE.equals( color ) )
         return 16777215;
      if( Color.YELLOW.equals( color ) )
         return 65535;

      return 0;
   }

   // -------------------------------------------------------------------------
   // Name:
   // Return:
   // Purpose:
   // -------------------------------------------------------------------------
   static public Color computeColor( String color )
   {
      if( color.equals( "Black" ) )
         return Color.BLACK;
      if( color.equals( "Blue" ) )
         return Color.BLUE;
      if( color.equals( "Cyan" ) )
         return Color.CYAN;
      if( color.equals( "Dark Gray" ) )
         return Color.DARK_GRAY;
      if( color.equals( "Gray" ) )
         return Color.GRAY;
      if( color.equals( "Green" ) )
         return Color.GREEN;
      if( color.equals( "Light Gray" ) )
         return Color.LIGHT_GRAY;
      if( color.equals( "Magenta" ) )
         return Color.MAGENTA;
      if( color.equals( "Orange" ) )
         return Color.ORANGE;
      if( color.equals( "Pink" ) )
         return Color.PINK;
      if( color.equals( "Red" ) )
         return Color.RED;
      if( color.equals( "White" ) )
         return Color.WHITE;
      if( color.equals( "Yellow" ) )
         return Color.YELLOW;

      return Color.BLACK;
   }

   // -------------------------------------------------------------------------
   // Name:
   // Return:
   // Purpose: To be compatiable with Xin's version
   // -------------------------------------------------------------------------
   static public Color computeColorComp( String color )
   {
      if( color.equals( "0" ) )
         return Color.BLACK;

      if( color.equals( "16711680" ) )  //blue
         return Color.BLUE;
      if( color.equals( "8388608" ) )  //navy
         return Color.BLUE;
      if( color.equals( "8421376" ) )  //teal
         return Color.BLUE;

      if( color.equals( "16776960" ) )  //aqua
         return Color.CYAN;

      if( color.equals( "8421504" ) ) // Gray
         return Color.GRAY;

      if( color.equals( "32768" ) ) // green
         return Color.GREEN;

      if( color.equals( "12632256" ) ) //silver
         return Color.LIGHT_GRAY;

      if( color.equals( "16711935" ) )  // fuchia
         return Color.MAGENTA;
      if( color.equals( "8388736" ) ) // purple
         return Color.MAGENTA;

      if( color.equals( "65280" ) )  //lime
         return Color.GREEN;

      if( color.equals( "255" ) ) // red
         return Color.RED;
      if( color.equals( "128" ) ) // maroon
         return Color.RED;

      if( color.equals( "16777215" ) ) // white
         return Color.WHITE;
      if( color.equals( "65535" ) ) // yellow
         return Color.YELLOW;
      if( color.equals( "32896" ) ) // olive
         return Color.YELLOW;

      return Color.BLACK;
   }
}