// -------------------------------------------------------------------------
// Name: Christopher Santamaria
// Date:
//--------------------------------------------------------------------------

//Modified 11/18/04 by A.N.

import javax.swing.*;
import java.awt.event.*;
import java.awt.*;
import java.io.*;

public class StudentMenu extends JMenuBar implements ActionListener
{
   // File Menu
   JMenu fileMenu = null;
   JMenuItem exitItem = null;

   // Emotion Menu
   JMenu emotionMenu = null;
   ButtonGroup radioGroup = null;
   JRadioButtonMenuItem happyItem = null;
   JRadioButtonMenuItem sadItem = null;
   JRadioButtonMenuItem winkingItem = null;
   JRadioButtonMenuItem cryingItem = null;
   JRadioButtonMenuItem yesItem = null;
   JRadioButtonMenuItem noItem = null;

   // Chat Size Menu
   JMenu chatPanelSizeMenu = null;
   ButtonGroup chatGroup = null;
   JMenuItem smallItem = null;
   JMenuItem mediumItem = null;
   JMenuItem largeItem = null;

   // Help Menu
   JMenu helpMenu = null;
   JMenuItem helpItem = null;
   JMenuItem exitHelp = null;

   // -------------------------------------------------------------------------
   // Name:
   // Return:
   // Purpose:
   // -------------------------------------------------------------------------
   public StudentMenu() {
      super();

      // File Menu
      initializeFileMenu();   

      // Emotion Menu
      initializeEmoticonMenu();

      // Chat Menu
      initializeChatPanelSizeMenu();

      // Help Menu
      initializeHelpMenu();   

      add( fileMenu );
      add( emotionMenu );
      add( chatPanelSizeMenu );
      add( helpMenu );
   }

   // -------------------------------------------------------------------------
   // Purpose:
   // -------------------------------------------------------------------------
   private void initializeFileMenu() {
      fileMenu = new JMenu( "File" );

      exitItem = new JMenuItem( "Exit" );
      exitItem.addActionListener( this );

      fileMenu.add( exitItem );
   }

   // -------------------------------------------------------------------------
   // Purpose:
   // -------------------------------------------------------------------------
   private void initializeEmoticonMenu() {

      // Default emoticons path
      String defaultPath = "images" + File.separator + 
         "DefaultEmoticons" + File.separator;

      emotionMenu = new JMenu( "My Emotion" );

      happyItem = new JRadioButtonMenuItem( "Happy", true );
      happyItem.addActionListener( this );

      sadItem = new JRadioButtonMenuItem( "Sad", false );
      sadItem.addActionListener( this );

      winkingItem = new JRadioButtonMenuItem( "Winking", false );
      winkingItem.addActionListener( this );

      cryingItem = new JRadioButtonMenuItem( "Crying", false );
      cryingItem.addActionListener( this );

      yesItem = new JRadioButtonMenuItem( "Yes", false );
      yesItem.addActionListener( this );

      noItem = new JRadioButtonMenuItem( "No", false );
      noItem.addActionListener( this );

      setToDefaultIcon();

      emotionMenu.add( happyItem );
      emotionMenu.add( sadItem );
      emotionMenu.add( winkingItem );
      emotionMenu.add( cryingItem );
      emotionMenu.add( yesItem );
      emotionMenu.add( noItem );

      // Radio group
      radioGroup = new ButtonGroup();
      radioGroup.add( happyItem );
      radioGroup.add( sadItem );
      radioGroup.add( winkingItem );
      radioGroup.add( cryingItem );
      radioGroup.add( yesItem );
      radioGroup.add( noItem );
   }

   // -------------------------------------------------------------------------
   // Purpose:
   // -------------------------------------------------------------------------
   private void initializeChatPanelSizeMenu() {
      chatPanelSizeMenu = new JMenu( "Chat Panel Size" );

      smallItem = new JRadioButtonMenuItem( "Small", true );
      smallItem.addActionListener( this );
      mediumItem = new JRadioButtonMenuItem( "Medium", false );
      mediumItem.addActionListener( this );
      largeItem = new JRadioButtonMenuItem( "Large", false );
      largeItem.addActionListener( this );

      chatPanelSizeMenu.add( smallItem );
      chatPanelSizeMenu.add( mediumItem );
      chatPanelSizeMenu.add( largeItem );

      // Radio group
      chatGroup = new ButtonGroup();
      chatGroup.add( smallItem );
      chatGroup.add( mediumItem );
      chatGroup.add( largeItem );
   }

   // -------------------------------------------------------------------------
   // Purpose:
   // -------------------------------------------------------------------------
   private void initializeHelpMenu() {
      helpMenu = new JMenu( "Help" );

      helpItem = new JMenuItem( "Help" );
      exitHelp = new JMenuItem( "Exit Help");

      helpItem.addActionListener( this );
      exitHelp.addActionListener( this );
   
      helpMenu.add( helpItem );
      helpMenu.add( exitHelp);
   }

   // -------------------------------------------------------------------------
   // Purpose:
   // -------------------------------------------------------------------------
   public void setToDefaultIcon() {

      // Default emoticons path
      String defaultPath = "images" + File.separator + 
         "DefaultEmoticons" + File.separator;

      reloadImageIcon( happyItem, defaultPath + "online.jpg" );

      reloadImageIcon( sadItem, defaultPath + "sad.jpg" );

      reloadImageIcon( winkingItem, defaultPath + "winking.jpg" );

      reloadImageIcon( cryingItem, defaultPath + "crying.jpg" );

      reloadImageIcon( yesItem, defaultPath + "yes.jpg" );

      reloadImageIcon( noItem, defaultPath + "no.jpg" );

   }

   // -------------------------------------------------------------------------
   // Purpose:
   // -------------------------------------------------------------------------
   public void updateImage() {

      // Default emoticons path
      String defaultPath = "images" + File.separator + 
         "DefaultEmoticons" + File.separator;

      // Image store path
      String imageStorePath = "images" + File.separator + 
         "ImageStore" + File.separator + Global.myFirstName.toLowerCase() + "-" + 
         Global.myLastName.toLowerCase()  + "-" + Global.className.toLowerCase()  + "-";  

      File file = null;

      file = new File( imageStorePath + "online.jpg" );
      if( file.exists() == true ) {
         reloadImageIcon( happyItem, imageStorePath + "online.jpg" );
      } else {
         reloadImageIcon( happyItem, defaultPath + "online.jpg" );
      }

      file = new File( imageStorePath + "sad.jpg" );
      if( file.exists() == true ) {
         reloadImageIcon( sadItem, imageStorePath + "sad.jpg" );
      } else {
         reloadImageIcon( sadItem, defaultPath + "sad.jpg" );
      }

      file = new File( imageStorePath + "winking.jpg" );
      if( file.exists() == true ) {
         reloadImageIcon( winkingItem, imageStorePath + "winking.jpg" );
      } else {
         reloadImageIcon( winkingItem, defaultPath + "winking.jpg" );
      }

      file = new File( imageStorePath + "crying.jpg" );
      if( file.exists() == true ) {
         reloadImageIcon( cryingItem, imageStorePath + "crying.jpg" );
      } else {
         reloadImageIcon( cryingItem, defaultPath + "crying.jpg" );
      }

      file = new File( imageStorePath + "yes.jpg" );
      if( file.exists() == true ) {
         reloadImageIcon( yesItem, imageStorePath + "yes.jpg" );
      } else {
         reloadImageIcon( yesItem, defaultPath + "yes.jpg" );
      }

      file = new File( imageStorePath + "no.jpg" );
      if( file.exists() == true ) {
         reloadImageIcon( noItem, imageStorePath + "no.jpg" );
      } else {
         reloadImageIcon( noItem, defaultPath + "no.jpg" );
      }

      repaint();
   }

   // -------------------------------------------------------------------------
   // Purpose:
   // -------------------------------------------------------------------------
   private void reloadImageIcon( JRadioButtonMenuItem menuItem, String fileName ) {

      // Flush old icon
      menuItem.setIcon( (ImageIcon) null );

      FileConverter fc = new FileConverter();
      menuItem.setIcon( new ImageIcon( fc.readFile( fileName ) ) );

      fc = null;
   }  

   // -------------------------------------------------------------------------
   // Name:
   // Return:
   // Purpose:
   // -------------------------------------------------------------------------
   public void actionPerformed( ActionEvent e )
   {
      JMenuItem item = (JMenuItem)e.getSource();

      StudentJLabel myself = Global.classroomPanel.findStudent( Global.myFirstName + " " + Global.myLastName );


      if( item == exitItem ) {
         String question = "Do you want to save a copy of the current transcript and then run the Relational Index?";

         int retVal = JOptionPane.showConfirmDialog( null,
                                                     question,
                                                     "RelationalIndex",
                                                     JOptionPane.YES_NO_OPTION );

         if( retVal == JOptionPane.YES_OPTION ) {
            runRelationalIndex();
         }

         System.exit( 1 );
      }
      else if( item == happyItem ) {
        sendUpdateMessage( StaticFunctions.HAPPY );
      }
      else if( item == sadItem ) {
        sendUpdateMessage( StaticFunctions.SAD );
      }
      else if( item == winkingItem ) {
        sendUpdateMessage( StaticFunctions.WINKING );
      }
      else if( item == cryingItem ) {
        sendUpdateMessage( StaticFunctions.CRYING );
      }
      else if( item == yesItem ) {
         sendUpdateMessage( StaticFunctions.YES );
      }
      else if( item == noItem ) {
         sendUpdateMessage( StaticFunctions.NO );
      }
      else if( item == smallItem ) {
         Global.chatPanel.set( new Dimension( 400, 300 ) );
      }
      else if( item == mediumItem ) {
         Global.chatPanel.set( new Dimension( 500, 400 ) );
      }
      else if( item == largeItem ) {
         Global.chatPanel.set( new Dimension( 600, 500 ) );
      }
      else if( item == helpItem) {

         if (Global.helpBrowser == null) {
            JTabbedPane pane = Global.tabbedPane.tabbedPane;

            Global.helpBrowser = new WebBrowser( );
            Global.tabbedPane.addPane( Global.helpBrowser, "Help" );

            if(Global.helpThread == null) {
               Global.helpThread = new Thread( Global.helpBrowser );
               Global.helpThread.start();
            }

            Global.helpBrowser.setThePage(Global.helpAddress );
         }
     }
     else if( item == exitHelp) {
        //Remove help tab
        JTabbedPane pane = Global.tabbedPane.tabbedPane;

        if(pane.indexOfTab("Help") != -1)
           pane.remove(pane.indexOfTab("Help"));

        Global.helpBrowser = null;
     }

   } // End void actionPerformed( ActionEvent )

   // -------------------------------------------------------------------------
   // Name:
   // Return:
   // Purpose:
   // -------------------------------------------------------------------------
   private void sendUpdateMessage( int status )
   {
      OutgoingMessage msg = new OutgoingMessage();

      msg.append( Integer.toString( StaticFunctions.COMMAND_UPDATE ) );
      msg.append( Integer.toString( status ) );

      // Bug: Send publish message
      Global.virtualClassroomThread.virtualClassroomSend( msg );
   }

   // -------------------------------------------------------------------------
   // Name:
   // Return:
   // Purpose:
   // -------------------------------------------------------------------------
   private void runRelationalIndex()
   {
      File file = null;

      // Used to hold text from the text areas
      String text = null;

      // Holds the file chooser used to save transcripts
      JFileChooser fc = new JFileChooser();

      int returnVal = fc.showSaveDialog( null );

      // Save messageTextPane text
      if( returnVal == JFileChooser.APPROVE_OPTION ) {

         // get selected text
         file = fc.getSelectedFile();

         // open file writer and write out text
         try {
            FileWriter out = new FileWriter( file );

            // Write out file
            out.write( Global.chatPanel.getTranscript() );

            // Flush the stream
            out.flush();
            out.close();
            out = null;
         }
         catch( IOException IO ) {
            System.out.println( "Error writing chat transcript to disk" );
            return;
         }
   
         RelationalIndexWindow riw = new RelationalIndexWindow( file.getName(), "Keywords.txt", "rIndex.txt" );
         riw.showDialog(  (Component)null );

         RelationalIndex ri = new RelationalIndex( riw.getTranscriptFileName(),
                                                riw.getKeywordFileName(),
                                                riw.getFreqFileName() );
      } // End if

   } // End runRelationalIndex()

} // End StudentMenu Class