// -------------------------------------------------------------------------
// Name: Christopher Santamaria
// Date:
//--------------------------------------------------------------------------

import javax.swing.JTabbedPane;
import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JFrame;
import javax.swing.JComponent;
import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.GridLayout;
import java.awt.event.KeyEvent;
import javax.swing.JSplitPane;
import javax.swing.*;
import java.awt.event.*;
import java.awt.*;

public class TeacherInterface extends JFrame {

   // -------------------------------------------------------------------------
   // Purpose:
   // -------------------------------------------------------------------------
   public void createChatPanel( Dimension d ) {
      Global.chatPanel = new ChatPanel( "Classroom Chat", d );

      Global.chatScrollPanel = new JScrollPane( Global.chatPanel );
      Global.chatScrollPanel.setPreferredSize( new Dimension( 800, 475 ) );
      Global.chatScrollPanel.setHorizontalScrollBarPolicy( JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
      Global.chatScrollPanel.setVerticalScrollBarPolicy( JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);

      Global.splitPane.setBottomComponent( Global.chatScrollPanel );
   }

   // -------------------------------------------------------------------------
   // Purpose:
   // -------------------------------------------------------------------------
   public void getUserInfo( String[] args ) {

      if( args.length != 3 ) {
         //Get password and user name first
         Global.loginWindow.showDialog( this );

         Global.myFirstName = Global.loginWindow.getFirstName();
         Global.myLastName = Global.loginWindow.getLastName();
         Global.myPassword = Global.loginWindow.getPassword();
      } else {
         Global.myFirstName = args[0];
         Global.myLastName = args[1];
         Global.myPassword = args[2];
      }

   }

   // -------------------------------------------------------------------------
   // Purpose:
   // -------------------------------------------------------------------------
   public TeacherInterface( String[] args ) {

      //Create and set up the window.
      super( "Virtual Classroom Teacher Tool 4.10 with Face Alive" );

      // User information
      getUserInfo( args );

      //Make sure we have nice window decorations.
      setDefaultLookAndFeelDecorated( true );

      setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

      Global.studentMenu = new StudentMenu();
      Global.statusMenu = new StatusMenu();

      // Set Menubar
      setJMenuBar( Global.studentMenu );

      // Create SplitPane
      Global.splitPane = new JSplitPane( JSplitPane.VERTICAL_SPLIT );
      Global.tabbedPane = new TabbedPane();

      Global.splitPane.setTopComponent( Global.tabbedPane );

      createChatPanel( new Dimension( 400, 300 ) );

      getContentPane().add( Global.splitPane, BorderLayout.CENTER );
      getContentPane().add( Global.statusMenu, BorderLayout.SOUTH );

      //Display the window.
      pack();

      // Load speach agent
      Global.speechAgent = new SpeechAgent();
      Global.speechAgent.start();

      // Name server thread
      Global.nameServerThread = new NameServerThread();
      Global.nameServerThread.start();
   }

   // -------------------------------------------------------------------------
   // Purpose:
   // -------------------------------------------------------------------------
   static public void main( String args[] )
   {
      Global.ti = new TeacherInterface( args );
      Global.ti.setVisible(true);
   }
}