// -------------------------------------------------------------------------
// Name: Anna Nys
// Date: 11.15.04
//--------------------------------------------------------------------------

//Modified 3.10.05 - AN

import java.io.*;
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;


public class TeacherVT extends JSplitPane
{
	boolean debug = false;
	boolean imported = false;

	TestImport testImport = null;

	//Variables to keep track of the state of VT
	int getClass;
	int getTest;
	int getQuestion;
	int timesUp;

	//To save test to .txt file
	JFileChooser fc;

	JProgressBar progressBar;

	int studentCount=0;
	Student students[];
	String Test = "";
	String showText="";

	JPanel studentPanel;
	JPanel teacherPanel;
	JPanel testPanel;
	JPanel questionPanel;
	JPanel infoPanel;
	JPanel progSavePanel;
	JPanel filler1, filler2;

	JTextArea txt_question;
	JScrollPane StudentScrollPane, QuestionScrollPane;
	JLabel status;
	JButton start;
	JButton stop;
	JButton save;

	Post postPanel=null;
	Question newQuestion=null;
	Vector answers = new Vector();
	String correctAnswer;

	int numQuestions = 0; //Interactive test	

	// Used to enforce the layout policy
    GridBagLayout gridBagLayout = null;
    GridBagConstraints gridBagConst = null;
    Insets inst = null;

 	// -------------------------------------------------------------------------
    // Name: addComponent( Component, int, int, int, int )
    // Return: void
    // Purpose: To add c to the gridbaglayout with passed in constraints
    // -------------------------------------------------------------------------
    private void addComponent( JPanel p, Component c, int row, int column, int width, int height )
    {
       // set gridx and gridy
       gridBagConst.gridx = column;
       gridBagConst.gridy = row;

       // set gridwidth and gridheight
       gridBagConst.gridwidth = width;
       gridBagConst.gridheight = height;

       // set constrants
       gridBagLayout.setConstraints( c, gridBagConst );

       // Add component to layout
       p.add( c );
    }


    public TeacherVT()
	{
		super(JSplitPane.HORIZONTAL_SPLIT);

		// Set up layout for studentPanel
		gridBagLayout = new GridBagLayout();
		gridBagConst = new GridBagConstraints();
		inst = new Insets( 1, 1, 1, 1 );
		gridBagConst.insets = inst;

		getClass=0;
		getTest=0;
		getQuestion=0;
		timesUp=0;

		fc = new JFileChooser(".");
		TextFilter filter = new TextFilter();
		fc.setFileFilter(filter);

		progressBar = new JProgressBar();
		progressBar.setIndeterminate(true);

		studentPanel=new JPanel();
		studentPanel.setLayout( gridBagLayout );

		teacherPanel=new JPanel();
		testPanel=new JPanel();
		questionPanel=new JPanel();
		infoPanel = new JPanel();
		progSavePanel = new JPanel();
		filler1 = new JPanel();
		filler2 = new JPanel();

		txt_question = new JTextArea(10,40);
		txt_question.setEditable(false);
		txt_question.setFont(new Font("TimesRoman", Font.BOLD, 14));

		QuestionScrollPane = new JScrollPane(txt_question);
		StudentScrollPane = new JScrollPane(studentPanel);		

		status = new JLabel();
		status.setVisible(false);

		start = new JButton("Start Test");
		start.setEnabled(false);

		stop = new JButton("End Test");
		stop.setEnabled(false);

		save = new JButton(new ImageIcon("images/save.gif"));
		save.setEnabled(false);

		testPanel.setLayout(new GridLayout(1,2));
		testPanel.add(start);
		testPanel.add(stop);

		progSavePanel.setLayout(new GridLayout(1,2));
		progSavePanel.add(progressBar);
		progSavePanel.add(save);

		postPanel = new Post();
		postPanel.disablePanel();
		Global.postPanel = postPanel;

		teacherPanel.setLayout( new BorderLayout() );
		teacherPanel.add(testPanel, BorderLayout.NORTH);
		teacherPanel.add(postPanel, BorderLayout.CENTER);
		teacherPanel.add(progSavePanel, BorderLayout.SOUTH);

		ButtonHandler btn_handler = new ButtonHandler();
		start.addActionListener(btn_handler);
		stop.addActionListener(btn_handler);
		save.addActionListener(btn_handler);

		setLeftComponent( StudentScrollPane );
		setRightComponent( teacherPanel );

		setDividerLocation ( 490 );
		setMinimumSize(new Dimension(800,500));
    }

	//Inner class for button event handling
	private class ButtonHandler implements ActionListener{
		public void actionPerformed(ActionEvent e)
		{
			if (e.getSource() == start)
			{
				OutgoingMessage msg = new OutgoingMessage(StaticFunctions.COMMAND_START_TEST);

				//Send message
				Global.virtualClassroomThread.virtualClassroomSend(msg);

				/* -- Start Modification -- */
				int answer;
				answer=JOptionPane.showConfirmDialog(null, "Would you like to import a test?", "Test Import", JOptionPane.YES_NO_OPTION);

				if(answer==0)  //Import test
				{
					imported = true;
					testImport = new TestImport();
					testImport.GetQuestions();
					testImport.LoadQuestion(0);
		        }
		        else
		        {
					imported = false;
				}

				/* -- End Modification -- */

			}
			else if (e.getSource() == stop)
			{
				OutgoingMessage msg = new OutgoingMessage(StaticFunctions.COMMAND_END_TEST);

				//Send message
				Global.virtualClassroomThread.virtualClassroomSend(msg);
			}

			/** Modified by A.N. 3/05 **/
			else
			{
				int retval = fc.showSaveDialog(null);
		        if (retval == JFileChooser.APPROVE_OPTION)
				{

					/* -- Start Modification -- */
					File txtFile = fc.getSelectedFile();
					File xmlFile = null;

					String xmlData = null;
					String xmlFileName = null;
					String txtFileName = null;
					String xmlFileArray[] = null;

					BufferedWriter out = null;

					//get the txt file path
					txtFileName = txtFile.getAbsolutePath();

					/* Check the extension of typed in file name*/
					if( Utils.getExtension(txtFile) == null)
						txtFileName = Utils.setTextExtension(txtFileName);

					if(debug)
						System.out.println("You chose to save to this file: " + txtFileName);

					// get the xml file name
					xmlFileName = txtFileName;
					if ( xmlFileName.endsWith(".txt") )
						xmlFileName = xmlFileName.replaceFirst(".txt", ".xml");

					Test = "Test "+Global.testNum+"\n\n"+Test;
					try {

						//Write out to .txt file
 						out = new BufferedWriter(new FileWriter(txtFileName));
						out.write(Test);
						out.flush();

						//Write out to .xml file
						out = new BufferedWriter(new FileWriter(xmlFileName));
						xmlData = TestToXML.Convert( Test );
						out.write(xmlData);

						out.flush();
						out.close();
						out = null;
					}
					catch (IOException f) {
						System.out.println("\nError writing test to disk");
					}
					/* -- End Modification -- */
				}

			}
		}
	}

	/* Begin new question */
	public void initQuestion()
	{
		Global.disableUpdates = false;

		//Reset students' icons
		Student st;
		for (int i=0; i<studentCount; i++)
		{
			st=students[i];
			st.changeState(st.getState());
			st.resetAnswer();
		}
		//status.setVisible(false);
		timesUp=0;
		correctAnswer="";
	}

	/* Begin new test */
    public void initTest()
	{
		Global.disableUpdates = false;
		Global.startedTest = false;

		//Reset students' icons
		Student st;
		for (int i=0; i<studentCount; i++)
		{
			st=students[i];
			st.changeState(st.getState());
			st.resetAnswer();
			st.setNumCorrect(0);  //added 1/05 by A.N.
		}
		save.setEnabled(false);
		status.setVisible(false);

		getTest=0;
		getQuestion=0;
		timesUp=0;
		numQuestions=0;
		correctAnswer="";
		newQuestion=null;
		answers = new Vector();
		Test="Class "+ Global.className + "\n\n";
		postPanel.init();
	}

	/* Display students in the class */
    public void generateClass(IncomingMessage msg)
	{
	   String fName, lName;
	   int state;

       studentCount = ( msg.getMessageSize() - 2 ) / 2;
       students = new Student[ studentCount ];

       // Retrieve Students from the msg
       for( int i = 0; i < studentCount; i++  )
       {
          fName = msg.getNextVariable();
          lName = msg.getNextVariable();

          students[i] = new Student( fName, lName, StaticFunctions.OFFLINE);
	  }

      int row = 0, column = 0;
      for( int i = 0; i < studentCount; i++  )
      {
         addComponent( studentPanel, students[i], row, column, 1, 1 );

         column++;

         if( column == 4 )
         { column = 0; row++; }
      }
	  //Class is generated
	  getClass=1;  //Can be used for error-handling

	  //Ready to begin test
	  start.setEnabled(true);

	  postPanel.setCourseNo(Global.className);
	}

	/* Display current question, record question and answer */
	public void displayQuestion()
	{
		showText = "(" + newQuestion.getNumber() + ")  ";
		showText += newQuestion.getQuestion() + "\n";

		if( (newQuestion.getType()).equals("0")) //multiple choice
		{
			showText+="A: "+newQuestion.getChoices()[0]+"\n";
			showText+="B: "+newQuestion.getChoices()[1]+"\n";
			showText+="C: "+newQuestion.getChoices()[2]+"\n";
			showText+="D: "+newQuestion.getChoices()[3]+"\n";
			showText+="E: "+newQuestion.getChoices()[4]+"\n";
		}

		/* -- Start modification -- */
		else  if( (newQuestion.getType()).equals("1"))// T/F
		{
			showText+="True or False?\n";
		}
		else
		{
			showText+="Fill in the blank\n";
		}

		txt_question.append(showText);
		txt_question.append("Time: "+newQuestion.getTime()+"\n\n\n");

		Test+=showText;
		Test+="Time: "+newQuestion.getTime()+"\n";

		if( (newQuestion.getType()).equals("2"))
			Test+="Answer: "+newQuestion.getShortAnswer()+"\n\n";
		else
			Test+="Answer: "+newQuestion.getAnswer()+"\n\n";

		/* -- End modification -- */
	}

	/*  Timer will go off once given time for a question expires, then
	    the processing of answers can begin */
	public void startTimer(int t)
	{
		int numberOfMillisecondsInTheFuture = 60000 * t; // 60 sec * t min
        int numTimers = numberOfMillisecondsInTheFuture/5000;  //update progress bar every 5 seconds.

		progressBar.setMaximum(60*t);
		progressBar.setValue(0);
		progressBar.setIndeterminate(false);
		progressBar.setStringPainted(true);

		PartialTimer [] timers = new PartialTimer[numTimers];

		//Set up times when timers should go off
		for (int i=0; i<numTimers; i++)
		{
			timers[i] = new PartialTimer(i,	new Date(System.currentTimeMillis()+((i+1)*(5000))) );
		}

		//Schedule all timers up to the last one
		for (int i=0; i<numTimers-1; i++)
		{
			timers[i].timer.schedule(new TimerTask()
			{
				int ProgressBarValue=0;
				public void run() {
					//Update progress bar
					ProgressBarValue = progressBar.getValue();
					progressBar.setValue(ProgressBarValue+5);

				}
			}, timers[i].timeToRun);

		}

		//Schedule last timer--times up for answering question
		timers[numTimers-1].timer.schedule(new TimerTask() {
			int ProgressBarValue=0;
            public void run() {
                // Task here ...
				timesUp=1;

				//Disable icon updates until next question is posted
				Global.disableUpdates = true;

				//Update progress bar
				ProgressBarValue = progressBar.getValue();
				progressBar.setValue(ProgressBarValue+5);

				postPanel.enablePanel();
				stop.setEnabled(true);
				getQuestion=0;
				processAnswers();

				//Import test: load next questions
				if( imported )
				{
					if( testImport.getCurrQuestion() < testImport.getQuestionCount() )
						testImport.LoadQuestion( testImport.getCurrQuestion() );
				}
            }
        }, timers[numTimers-1].timeToRun);
	}

	/*Find a student in students vector based on name*/
	public Student findStudent(String fn, String ln)
	{
		Student s;
		for (int i=0; i<studentCount; i++)
		{
		   	s=students[i];
			if(ln.equalsIgnoreCase(s.getLname()) && fn.equalsIgnoreCase(s.getFname()) )
				return s;
		}
		return null;
	}

	/*Find a student's answer in the answers array based on name
	  Returns index of answer, if found. -1, if not found*/
	public int findAnswer(String fn, String ln)
	{
		Answer a;
		for (int i=0; i<answers.size(); i++)
		{
			a=(Answer)answers.elementAt(i);
			if(ln.equals(a.getLname()) && fn.equals(a.getFname()) )
				return i;
		}
		return -1;
	}

	/* Change student's state */
	public void changeState(IncomingMessage msg)
	{
		Student s = null;
		int status;
		s=findStudent(msg.getFirstName(), msg.getLastName());
		status = Integer.parseInt(msg.message[4]);

		if(s != null)
		{
			s.changeState(status);
		}
	}

	/* Update student states */
    public void updateStudents( IncomingMessage msg )
    {
       String studentFirstName, studentLastName, status;
       Student student = null;

	   msg.getNextVariable();

       while( msg.hasMoreVariables() )
       {
          studentFirstName = msg.getNextVariable();
          studentLastName = msg.getNextVariable();
          status = msg.getNextVariable();

          student = findStudent( studentFirstName, studentLastName );

          if( student != null )
             student.changeState( Integer.parseInt( status ) );
       }
    }

	/* At the end of the time period, display students' answers,
	   and record the answers for grading */
	public void processAnswers()
	{
		Answer a=null;
		Student s=null;
		for (int i=0; i<answers.size(); i++)
		{
			a=(Answer)answers.elementAt(i);
			s=findStudent(a.getFname(), a.getLname());

			if( (a.getType()).equals("0") )
			{
				//System.out.println("Setting MC or TF answer");
				s.changeIcon(a.getAnswer());
				s.setAnswered(1);
				if(correctAnswer.equals(a.getAnswer()) )
					s.incNumCorrect();
				a.resetAnswer();
			}
			else
			{
				//System.out.println("Setting short answer");
				s.setShortAnswer(a.getShortAnswer());
				s.setAnswered(1);
				if(correctAnswer.equalsIgnoreCase(a.getShortAnswer()) )
					s.incNumCorrect();
				a.resetAnswer();
			}
		}

		//For all students who are online and haven't answered, change icons
		for (int i=0; i<studentCount; i++)
		{
			s=students[i];
			if(s.getAnswered() == 1)
				s.setAnswered(0);
			else if (s.getAnswered() == 0 && s.getState() != StaticFunctions.OFFLINE)
				s.changeIcon("S");
		}
		repaint();
	}

	public void startTest()
	{
		initTest();

		//Test is in progress
		getTest=1;	//Can be used for error-handling

		start.setEnabled(false);
		stop.setEnabled(true);
		postPanel.enablePanel();
	}

	public void receiveQuestion(IncomingMessage msg)
	{
  		//Question is in progress
		getQuestion=1; //Can be used for error-handling

		newQuestion = new Question();
		initQuestion();

		newQuestion.loadQuestion(msg);
		numQuestions++;

		displayQuestion();

		Global.testNum=newQuestion.getTestNum();
		Global.quesNum=newQuestion.getNumber();

		//Set the testNum and quesNum globals
		if(!Global.startedTest)
		{
			   Global.nextQuesNum = Global.quesNum;
		}

		//Increment nextQuesNum
		Integer currQuesNum = new Integer(Global.nextQuesNum);
		int nextQuesNum = (currQuesNum.intValue())+1;
		currQuesNum = new Integer(nextQuesNum);
		Global.nextQuesNum = currQuesNum.toString();

		Global.startedTest = true;

		if( (newQuestion.getType()).equals("2")) //short answer
		{
			correctAnswer=newQuestion.getShortAnswer();
		}
		else
		{
			correctAnswer=newQuestion.getAnswer();
		}

		postPanel.startNewQuestion();
		postPanel.disablePanel();

		stop.setEnabled(false);

		startTimer(Integer.parseInt(newQuestion.getTime()));
	}

	public void receiveAnswer(IncomingMessage msg)
	{
		Student s = null;
		Answer newAnswer = new Answer();
		newAnswer.loadAnswer(msg);

		s=findStudent(newAnswer.getFname(), newAnswer.getLname());

		int index;

		//A student can re-submit an answer before time is up
		if( (index=findAnswer(s.getFname(), s.getLname())) == -1) //new answer
			answers.addElement(newAnswer);
		else
		    answers.setElementAt(newAnswer,index);  //Re-submitted answer
	}

	public void endTest()
	{
		//Generate a grade table
		GradeTable gradeTable = null;
		Object data[][] = new Object[studentCount+1][2];

		Integer questions = new Integer(numQuestions);
		Integer score;
		Integer index;

		Student s=null;
		OutgoingMessage msg = new OutgoingMessage(StaticFunctions.COMMAND_GRADES);

		msg.append( Global.testNum );
		msg.append( questions.toString());

		int i;
		//Add scores for all students
		for(i=0; i<studentCount; i++)
		{
			index=new Integer(i);
			s=students[i];
			score = new Integer(s.getNumCorrect());

			//Update gradeTable
			data[i][0]=s.getLname()+", "+s.getFname();
			data[i][1]=score.toString();

			//Add to Outgoing Message
			msg.append( s.getFname() );
			msg.append( s.getLname() );
			msg.append( score.toString() );

			s.setNumCorrect(0);  //reset each student's score
		}

		data[i][0]="Possible Points";
		data[i][1]=questions.toString();

		gradeTable = new GradeTable(data);
		
		// --- Added by C.G. 4/05 --- //
		Global.gradePanel.addScore(data,studentCount,Global.testNum);

		//Send message
		Global.virtualClassroomThread.virtualClassroomSend(msg);

		//Reset state for next test
		getTest=0; //No test in progress
		stop.setEnabled(false);
		save.setEnabled(true);
		postPanel.disablePanel();
		status.setVisible(false);
		start.setEnabled(true);
	}
}
