// -------------------------------------------------------------------------
// Name: Anna Nys
// Date: 3.30.05
//--------------------------------------------------------------------------

import org.jdom.*;
import org.jdom.input.*;
import org.jdom.output.*;

import java.lang.Integer;
import java.lang.Thread;
import java.util.List;
import java.util.Iterator;
import java.io.File;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;

public class TestImport
{
	public static boolean debug = false;
	public int currQuestion;
	public int numQuestions;
	public List questions;

	Element test = null;
	String test_no = null;
	String class_name = null;

	public TestImport()
	{
		currQuestion = 0;
		numQuestions = 0;
		questions = null;
	}

	public int getQuestionCount()
	{
		return numQuestions;
	}

	public List getQuestions()
	{
		return questions;
	}

	public int getCurrQuestion()
	{
		return currQuestion;
	}

	public String GetFile()
	{
		JFileChooser chooser = new JFileChooser();
		XMLFilter filter = new XMLFilter();
		chooser.setFileFilter(filter);

		int returnVal = chooser.showOpenDialog(null);
		if(returnVal == JFileChooser.APPROVE_OPTION)
		{
			if( debug )
				System.out.println("You chose to open this file: " + chooser.getSelectedFile().getName());
			return chooser.getSelectedFile().getPath();
		}

		return null;
	}

	public Document Load()
	{
		String xmlFileName = null;
		xmlFileName = GetFile();

		if( xmlFileName == null)
		{
			System.err.println("Error opening file\n" );
		}

		try
		{
			SAXBuilder builder = new SAXBuilder();
			Document document = builder.build( xmlFileName );
			return document;
		}
		catch (Exception e) {
			e.printStackTrace();
		}

		return null;
	}

	public void ShowQuestion ( Question newQuestion )
	{
		Post post = Global.postPanel;
		post.Reset();

		post.txt_TestNo.setText(newQuestion.getTestNum());
		post.txt_Question.setText(newQuestion.getQuestion());
		post.txt_No.setText(newQuestion.getNumber());

		String type;
		if( (newQuestion.getType()).equals("0"))
		{
			String choice[] = newQuestion.getChoices();
			//Set to MC
			post.radio_MC.setSelected(true);
			post.txt_Choice0.setText(choice[0]);
			post.txt_Choice1.setText(choice[1]);
			post.txt_Choice2.setText(choice[2]);
			post.txt_Choice3.setText(choice[3]);
			post.txt_Choice4.setText(choice[4]);
			post.combo_Answer.setSelectedItem( (Object)newQuestion.getAnswer());
		}
		else if ( (newQuestion.getType()).equals("1"))
		{
			//Set to T/F
			post.radio_TF.setSelected(true);
			if( "T".equals(newQuestion.getAnswer()) )
				post.combo_Answer.setSelectedItem( (Object)"True");
			else
				post.combo_Answer.setSelectedItem( (Object)"False");
		}
		else
		{
			//Set to Short Answer
			post.radio_SA.setSelected(true);
			post.txt_ShortAnswer.setText(newQuestion.getShortAnswer());
		}

		post.combo_Time.setSelectedItem( (Object)newQuestion.getTime());
	}

	public void GetQuestions()
	{
		Document doc = Load();

		if( doc == null)
			System.err.println("Error loading xml document\n");

		test = doc.getRootElement();
		test_no = test.getAttributeValue("No");
		class_name = test.getAttributeValue("Class");

		if( !class_name.equals(Global.className) )
			System.out.println("Wrong class!");

		questions = test.getChildren("question");
		numQuestions = questions.size();
	}

	public void LoadQuestion (int i)
	{
		Element ques = null;
		Question newQuestion = new Question();
		String type = null;
		String time = null;
		List options = null;

		ques = (Element)questions.get(i);

		newQuestion.setNumber( ques.getAttributeValue("No") );
		newQuestion.setTestNum( test_no );
		newQuestion.setQuestion( ques.getAttributeValue("Question") );

		time = ques.getChild("time").getTextTrim();
		type = ques.getChild("type").getTextTrim();

		newQuestion.setTime( time );

		if( type.equals("Multiple Choice") )
		{
			newQuestion.setType("0");
			//options = ques.getChildren("option");

			Iterator itr = (ques.getChildren("option")).iterator();
			int j = 0;
			String choices [] = {"","","","",""};
			Element child = null;
			while(itr.hasNext())
			{
				child = (Element)itr.next();
				choices[j] = child.getTextTrim();
				j++;
			}

			newQuestion.setChoices( choices );
			newQuestion.setAnswer( ques.getChild("answer").getTextTrim() );
		}

		else if( type.equals("Short Answer") )
		{
			newQuestion.setType("2");
			String [] choices = {"null","null","null","null","null"};
			newQuestion.setChoices( choices );
			newQuestion.setShortAnswer( ques.getChild("answer").getTextTrim() );
		}
		else //True/False
		{
			newQuestion.setType("1");
			String [] choices = {"null","null","null","null","null"};
			newQuestion.setChoices( choices );
			newQuestion.setAnswer( ques.getChild("answer").getTextTrim() );
		}

		ShowQuestion( newQuestion );

		currQuestion = i+1;
	}
}
