// -------------------------------------------------------------------------
// Name: Anna Nys
// Date: 3.10.05
//--------------------------------------------------------------------------

import java.io.*;
import java.util.regex.*;

public class TestToXML
{
	static boolean debug = false;

	static public String txtData;
	static public String xmlData;


	static public final String xmlDeclaration = "<?xml version='1.0' encoding='utf-8'?>";
	static public final String startTestTag = "<test";
	static public final String endTestTag = "</test>";
	static public final String startQuestionTag = "<question";
	static public final String endQuestionTag = "</question>";
	static public final String startAnswerTag = "<answer>";
	static public final String endAnswerTag = "</answer>";
	static public final String startTimeTag = "<time>";
	static public final String endTimeTag = "</time>";
	static public final String startTypeTag = "<type>";
	static public final String endTypeTag = "</type>";
	static public final String startOptionTag = "<option";
	static public final String endOptionTag = "</option>";

	static public String Convert(String text)
	{
		txtData = text;
		xmlData = "";

		String[] result = null;
		String[] stringArray = null;

		xmlData = xmlDeclaration + "\n";
		xmlData = xmlData + startTestTag + "\n";

		result = txtData.split("\n");

		if(debug)
		{
			System.out.println(txtData);
			System.out.println(result.length);
		}

		for (int x=0; x<result.length; x++)
	    {
			if(debug)
				System.out.println("Line: " + result[x]);

			if(result[x].equals(""))
				continue;

			//Class Name
			//Ex: "Class CS2310"
			if( result[x].startsWith("Class ") )
			{
				stringArray = result[x].split("\\s");
				xmlData = xmlData + " Class = \"" + stringArray[1] + "\">\n";
			}
			//Test heading
			//Ex: "Test 1"
			else if( result[x].startsWith("Test ") )
			{
				stringArray = result[x].split("\\s");
				xmlData = xmlData + " No = \"" + stringArray[1] + "\"\n";
			}
			//Question
			//Ex: "(1) Question"
			else if( result[x].startsWith("(") )
			{
				Pattern p = null;
				Matcher m = null;
				String no = "", ques = "";

				xmlData = xmlData + startQuestionTag + "\n";

				p = Pattern.compile("\\((\\d)\\)\\s\\s(.*)",Pattern.CASE_INSENSITIVE);
				m = p.matcher(result[x]);
				if( m.matches() )
				{
					no = m.group(1);
					ques = m.group(2);
					if( debug )
					{
						System.out.println(no);
						System.out.println(ques);
					}
				}

				xmlData = xmlData + " No = \"" + no + "\"\n";
				xmlData = xmlData + " Question = \"" + ques + "\">\n";
			}
			//Answer
			//Ex: "Answer: A"
			else if( result[x].startsWith("Answer:"))
			{
				xmlData = xmlData + startAnswerTag + "\n";

				//Split into: Answer, ans
				stringArray = result[x].split(":\\s");
				xmlData = xmlData + stringArray[1] + "\n";
				xmlData = xmlData + endAnswerTag + "\n";
				xmlData = xmlData + endQuestionTag + "\n";
			}
			//Time
			//Ex; "Time: 1"
			else if( result[x].startsWith("Time:"))
			{
				xmlData = xmlData + startTimeTag + "\n";

				//Split into: Time, time
				stringArray = result[x].split(":\\s");
				xmlData = xmlData + stringArray[1] + "\n";
				xmlData = xmlData + endTimeTag + "\n";
			}
			//Question type/options
			else
			{
				//type = T/F
				if( result[x].startsWith("True "))
				{
					xmlData = xmlData + startTypeTag + "\n";
					xmlData = xmlData + "True/False" + "\n";
					xmlData = xmlData + endTypeTag + "\n";
				}
				//type = Short Answer
				else if (result[x].startsWith("Fill "))
				{
					xmlData = xmlData + startTypeTag + "\n";
					xmlData = xmlData + "Short Answer" + "\n";
					xmlData = xmlData + endTypeTag + "\n";
				}
				//type = Multiple Choice
				else
				{
					//Add choice
					AddChoice(result[x]);
				}

			}

		}

		xmlData = xmlData + endTestTag + "\n";
		return xmlData;
	}

	static public void AddChoice(String choice)
	{
		String[] stringArray = null;

		if(choice.startsWith("A:"))
		{
			xmlData = xmlData + startTypeTag + "\n";
			xmlData = xmlData + "Multiple Choice" + "\n";
			xmlData = xmlData + endTypeTag + "\n";
		}

		//split into: letter,choice
		stringArray = choice.split(":\\s");
		xmlData = xmlData + startOptionTag + "\n";

		xmlData = xmlData + " Name = \"" + stringArray[0] + "\">\n";
		xmlData = xmlData + stringArray[1] +"\n";

		xmlData = xmlData + endOptionTag + "\n";
	}

}