// -------------------------------------------------------------------------
// Name: Anna Nys
// Date: 3.10.05
//--------------------------------------------------------------------------

public class TranscriptToXML
{

	static public String txtData;
	static public String xmlData;
	static public final String xmlDeclaration = "<?xml version='1.0' encoding='utf-8'?>";
	static public final String startTranscriptTag = "<transcript>";
	static public final String endTranscriptTag = "</transcript>";
	static public final String startMsgTag = "<message";
	static public final String endMsgTag = "</message>";
	static public final String startTxtTag = "<text>";
	static public final String endTxtTag = "</text>";

	static public String Convert(String text)
	{
		txtData = text;
		xmlData = "";

		xmlData = xmlDeclaration + "\n";
		xmlData = xmlData + startTranscriptTag + "\n";

		String[] result = null;
		String[] from = null;
		String[] fromto = null;

		boolean audioMsg;
		boolean privateMsg;
		boolean firstMsg = true;
		
		String systemNewline = System.getProperty("line.separator");
		result = txtData.split(systemNewline);

		for (int x=0; x<result.length; x++)
	    {
			audioMsg = false;
			privateMsg = false;

			//From
			if ( (result[x].startsWith("[")) && (result[x].endsWith("]")) )
			{
				if(!firstMsg)
				{
					//End previous message
					xmlData = xmlData + "\n"+ endMsgTag + "\n";
				}

				from = result[x].split("\\[|\\]");

				if(!from[1].equals(""))
				{
					int index;

					xmlData = xmlData + startMsgTag + "\n";

					//Audio message?
					if(from[1].startsWith("Audio"))
						audioMsg = true;

					//Private message?
					if( (index = from[1].indexOf("in Private")) != -1)
						privateMsg = true;

					if(audioMsg && privateMsg)
					{
						//Split into: "",From,To,Private
						fromto = from[1].split("Audio|\\bto\\b|\\bin\\b");
						xmlData = xmlData + " From= \"" + fromto[1] + "\"\n";
						xmlData = xmlData + " To= \"" + fromto[2] + "\"\n";
						xmlData = xmlData + " Audio= \"Yes\"\n";
					}
					else if(audioMsg)
					{
						//Split into: "", From
						fromto = from[1].split("Audio");
						xmlData = xmlData + " From= \""+ fromto[1] + "\"\n";
						xmlData = xmlData + " To= \"ALL\"" + "\n";
						xmlData = xmlData + " Audio= \"Yes\"\n";
					}
					else if(privateMsg)
					{
						//Split into: From,To,Private
						fromto = from[1].split("\\bto\\b|\\bin\\b");
						xmlData = xmlData + " From= \""+ fromto[0] + "\"\n";
						xmlData = xmlData + " To= \""+ fromto[1] + "\"\n";
						xmlData = xmlData + " Audio= \"No\"\n";
					}
					else
					{
						xmlData = xmlData + " From= \""+ from[1] + "\"\n";
						xmlData = xmlData + " To= \"ALL\"" + "\n";
						xmlData = xmlData + " Audio= \"No\"\n";
					}

					xmlData = xmlData + ">\n";
				}
				else  //Text
				{
					xmlData = xmlData + startTxtTag;
					xmlData = xmlData + result[x];
					xmlData = xmlData + endTxtTag + "\n";
				}

				firstMsg = false;
			}
			else //Text
			{
				xmlData = xmlData + startTxtTag;
				xmlData = xmlData + result[x];
				xmlData = xmlData + endTxtTag + "\n";
			}

		}

		//End last message
		xmlData = xmlData + "\n"+ endMsgTag + "\n";
		//End transcript
		xmlData = xmlData + endTranscriptTag + "\n";

		return xmlData;
	}

}